# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...core.datetime_utils import serialize_datetime

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class AccessPolicyResourceWriteCriteria(pydantic.BaseModel):
    """
    Invariants that must be satisfied for the resource to be written.
    """

    pre: typing.Optional[str] = pydantic.Field(
        default=None, description="Invariant to check against the state of the resource before modification."
    )
    post: typing.Optional[str] = pydantic.Field(
        default=None,
        description="Invariant to check against the state of the resource with modifications tentatively applied.",
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
