# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class ElementDefinitionBindingStrength(str, enum.Enum):
    """
    Indicates the degree of conformance expectations associated with this binding - that is, the degree to which the provided value set must be adhered to in the instances.
    """

    REQUIRED = "required"
    EXTENSIBLE = "extensible"
    PREFERRED = "preferred"
    EXAMPLE = "example"

    def visit(
        self,
        required: typing.Callable[[], T_Result],
        extensible: typing.Callable[[], T_Result],
        preferred: typing.Callable[[], T_Result],
        example: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is ElementDefinitionBindingStrength.REQUIRED:
            return required()
        if self is ElementDefinitionBindingStrength.EXTENSIBLE:
            return extensible()
        if self is ElementDefinitionBindingStrength.PREFERRED:
            return preferred()
        if self is ElementDefinitionBindingStrength.EXAMPLE:
            return example()
