# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class NamingSystemKind(str, enum.Enum):
    """
    Indicates the purpose for the naming system - what kinds of things does it make unique?
    """

    CODESYSTEM = "codesystem"
    IDENTIFIER = "identifier"
    ROOT = "root"

    def visit(
        self,
        codesystem: typing.Callable[[], T_Result],
        identifier: typing.Callable[[], T_Result],
        root: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is NamingSystemKind.CODESYSTEM:
            return codesystem()
        if self is NamingSystemKind.IDENTIFIER:
            return identifier()
        if self is NamingSystemKind.ROOT:
            return root()
