# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class PatientLinkType(str, enum.Enum):
    """
    The type of link between this patient resource and another patient resource.
    """

    REPLACED_BY = "replaced-by"
    REPLACES = "replaces"
    REFER = "refer"
    SEEALSO = "seealso"

    def visit(
        self,
        replaced_by: typing.Callable[[], T_Result],
        replaces: typing.Callable[[], T_Result],
        refer: typing.Callable[[], T_Result],
        seealso: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is PatientLinkType.REPLACED_BY:
            return replaced_by()
        if self is PatientLinkType.REPLACES:
            return replaces()
        if self is PatientLinkType.REFER:
            return refer()
        if self is PatientLinkType.SEEALSO:
            return seealso()
