# This file was auto-generated by Fern from our API Definition.

import typing

from .access_policy import AccessPolicy
from .account import Account
from .activity_definition import ActivityDefinition
from .adverse_event import AdverseEvent
from .agent import Agent
from .allergy_intolerance import AllergyIntolerance
from .appointment import Appointment
from .appointment_response import AppointmentResponse
from .async_job import AsyncJob
from .audit_event import AuditEvent
from .basic import Basic
from .binary import Binary
from .biologically_derived_product import BiologicallyDerivedProduct
from .body_structure import BodyStructure
from .bot import Bot
from .bulk_data_export import BulkDataExport
from .bundle import Bundle
from .capability_statement import CapabilityStatement
from .care_plan import CarePlan
from .care_team import CareTeam
from .catalog_entry import CatalogEntry
from .charge_item import ChargeItem
from .charge_item_definition import ChargeItemDefinition
from .claim import Claim
from .claim_response import ClaimResponse
from .client_application import ClientApplication
from .clinical_impression import ClinicalImpression
from .code_system import CodeSystem
from .communication import Communication
from .communication_request import CommunicationRequest
from .compartment_definition import CompartmentDefinition
from .composition import Composition
from .concept_map import ConceptMap
from .condition import Condition
from .consent import Consent
from .contract import Contract
from .coverage import Coverage
from .coverage_eligibility_request import CoverageEligibilityRequest
from .coverage_eligibility_response import CoverageEligibilityResponse
from .detected_issue import DetectedIssue
from .device import Device
from .device_definition import DeviceDefinition
from .device_metric import DeviceMetric
from .device_request import DeviceRequest
from .device_use_statement import DeviceUseStatement
from .diagnostic_report import DiagnosticReport
from .document_manifest import DocumentManifest
from .document_reference import DocumentReference
from .domain_configuration import DomainConfiguration
from .effect_evidence_synthesis import EffectEvidenceSynthesis
from .encounter import Encounter
from .endpoint import Endpoint
from .enrollment_request import EnrollmentRequest
from .enrollment_response import EnrollmentResponse
from .episode_of_care import EpisodeOfCare
from .event_definition import EventDefinition
from .evidence import Evidence
from .evidence_variable import EvidenceVariable
from .example_scenario import ExampleScenario
from .explanation_of_benefit import ExplanationOfBenefit
from .family_member_history import FamilyMemberHistory
from .flag import Flag
from .goal import Goal
from .graph_definition import GraphDefinition
from .group import Group
from .guidance_response import GuidanceResponse
from .healthcare_service import HealthcareService
from .imaging_study import ImagingStudy
from .immunization import Immunization
from .immunization_evaluation import ImmunizationEvaluation
from .immunization_recommendation import ImmunizationRecommendation
from .implementation_guide import ImplementationGuide
from .insurance_plan import InsurancePlan
from .invoice import Invoice
from .json_web_key import JsonWebKey
from .library import Library
from .linkage import Linkage
from .list import List
from .location import Location
from .login import Login
from .measure import Measure
from .measure_report import MeasureReport
from .media import Media
from .medication import Medication
from .medication_administration import MedicationAdministration
from .medication_dispense import MedicationDispense
from .medication_knowledge import MedicationKnowledge
from .medication_request import MedicationRequest
from .medication_statement import MedicationStatement
from .medicinal_product import MedicinalProduct
from .medicinal_product_authorization import MedicinalProductAuthorization
from .medicinal_product_contraindication import MedicinalProductContraindication
from .medicinal_product_indication import MedicinalProductIndication
from .medicinal_product_ingredient import MedicinalProductIngredient
from .medicinal_product_interaction import MedicinalProductInteraction
from .medicinal_product_manufactured import MedicinalProductManufactured
from .medicinal_product_packaged import MedicinalProductPackaged
from .medicinal_product_pharmaceutical import MedicinalProductPharmaceutical
from .medicinal_product_undesirable_effect import MedicinalProductUndesirableEffect
from .message_definition import MessageDefinition
from .message_header import MessageHeader
from .molecular_sequence import MolecularSequence
from .naming_system import NamingSystem
from .nutrition_order import NutritionOrder
from .observation import Observation
from .observation_definition import ObservationDefinition
from .operation_definition import OperationDefinition
from .operation_outcome import OperationOutcome
from .organization import Organization
from .organization_affiliation import OrganizationAffiliation
from .parameters import Parameters
from .password_change_request import PasswordChangeRequest
from .patient import Patient
from .payment_notice import PaymentNotice
from .payment_reconciliation import PaymentReconciliation
from .person import Person
from .plan_definition import PlanDefinition
from .practitioner import Practitioner
from .practitioner_role import PractitionerRole
from .procedure import Procedure
from .project import Project
from .project_membership import ProjectMembership
from .provenance import Provenance
from .questionnaire import Questionnaire
from .questionnaire_response import QuestionnaireResponse
from .related_person import RelatedPerson
from .request_group import RequestGroup
from .research_definition import ResearchDefinition
from .research_element_definition import ResearchElementDefinition
from .research_study import ResearchStudy
from .research_subject import ResearchSubject
from .risk_assessment import RiskAssessment
from .risk_evidence_synthesis import RiskEvidenceSynthesis
from .schedule import Schedule
from .search_parameter import SearchParameter
from .service_request import ServiceRequest
from .slot import Slot
from .smart_app_launch import SmartAppLaunch
from .specimen import Specimen
from .specimen_definition import SpecimenDefinition
from .structure_definition import StructureDefinition
from .structure_map import StructureMap
from .subscription import Subscription
from .substance import Substance
from .substance_nucleic_acid import SubstanceNucleicAcid
from .substance_polymer import SubstancePolymer
from .substance_protein import SubstanceProtein
from .substance_reference_information import SubstanceReferenceInformation
from .substance_source_material import SubstanceSourceMaterial
from .substance_specification import SubstanceSpecification
from .supply_delivery import SupplyDelivery
from .supply_request import SupplyRequest
from .task import Task
from .terminology_capabilities import TerminologyCapabilities
from .test_report import TestReport
from .test_script import TestScript
from .user import User
from .user_configuration import UserConfiguration
from .value_set import ValueSet
from .verification_result import VerificationResult
from .vision_prescription import VisionPrescription

ResourceList = typing.Union[
    Account,
    ActivityDefinition,
    AdverseEvent,
    AllergyIntolerance,
    Appointment,
    AppointmentResponse,
    AuditEvent,
    Basic,
    Binary,
    BiologicallyDerivedProduct,
    BodyStructure,
    Bundle,
    CapabilityStatement,
    CarePlan,
    CareTeam,
    CatalogEntry,
    ChargeItem,
    ChargeItemDefinition,
    Claim,
    ClaimResponse,
    ClinicalImpression,
    CodeSystem,
    Communication,
    CommunicationRequest,
    CompartmentDefinition,
    Composition,
    ConceptMap,
    Condition,
    Consent,
    Contract,
    Coverage,
    CoverageEligibilityRequest,
    CoverageEligibilityResponse,
    DetectedIssue,
    Device,
    DeviceDefinition,
    DeviceMetric,
    DeviceRequest,
    DeviceUseStatement,
    DiagnosticReport,
    DocumentManifest,
    DocumentReference,
    EffectEvidenceSynthesis,
    Encounter,
    Endpoint,
    EnrollmentRequest,
    EnrollmentResponse,
    EpisodeOfCare,
    EventDefinition,
    Evidence,
    EvidenceVariable,
    ExampleScenario,
    ExplanationOfBenefit,
    FamilyMemberHistory,
    Flag,
    Goal,
    GraphDefinition,
    Group,
    GuidanceResponse,
    HealthcareService,
    ImagingStudy,
    Immunization,
    ImmunizationEvaluation,
    ImmunizationRecommendation,
    ImplementationGuide,
    InsurancePlan,
    Invoice,
    Library,
    Linkage,
    List,
    Location,
    Measure,
    MeasureReport,
    Media,
    Medication,
    MedicationAdministration,
    MedicationDispense,
    MedicationKnowledge,
    MedicationRequest,
    MedicationStatement,
    MedicinalProduct,
    MedicinalProductAuthorization,
    MedicinalProductContraindication,
    MedicinalProductIndication,
    MedicinalProductIngredient,
    MedicinalProductInteraction,
    MedicinalProductManufactured,
    MedicinalProductPackaged,
    MedicinalProductPharmaceutical,
    MedicinalProductUndesirableEffect,
    MessageDefinition,
    MessageHeader,
    MolecularSequence,
    NamingSystem,
    NutritionOrder,
    Observation,
    ObservationDefinition,
    OperationDefinition,
    OperationOutcome,
    Organization,
    OrganizationAffiliation,
    Parameters,
    Patient,
    PaymentNotice,
    PaymentReconciliation,
    Person,
    PlanDefinition,
    Practitioner,
    PractitionerRole,
    Procedure,
    Provenance,
    Questionnaire,
    QuestionnaireResponse,
    RelatedPerson,
    RequestGroup,
    ResearchDefinition,
    ResearchElementDefinition,
    ResearchStudy,
    ResearchSubject,
    RiskAssessment,
    RiskEvidenceSynthesis,
    Schedule,
    SearchParameter,
    ServiceRequest,
    Slot,
    Specimen,
    SpecimenDefinition,
    StructureDefinition,
    StructureMap,
    Subscription,
    Substance,
    SubstanceNucleicAcid,
    SubstancePolymer,
    SubstanceProtein,
    SubstanceReferenceInformation,
    SubstanceSourceMaterial,
    SubstanceSpecification,
    SupplyDelivery,
    SupplyRequest,
    Task,
    TerminologyCapabilities,
    TestReport,
    TestScript,
    ValueSet,
    VerificationResult,
    VisionPrescription,
    Project,
    ClientApplication,
    User,
    Login,
    PasswordChangeRequest,
    JsonWebKey,
    Bot,
    AccessPolicy,
    UserConfiguration,
    ProjectMembership,
    BulkDataExport,
    SmartAppLaunch,
    DomainConfiguration,
    AsyncJob,
    Agent,
]
